require 'app_push/version'
require 'app_push/xiaomi'
require 'app_push/igetui'
require 'app_push/igetui/push'
require 'app_push/log'
require 'igetui'
require 'app_push/huawei'
module AppPush
  class Push
    class << self
      attr_accessor :igetui_config, :xiaomi_config
      def init(opts = {})
        opts = opts.with_indifferent_access
        # {
        #   base: {
        #     app_id: '',
        #     app_key: '',
        #     master_secret: ''
        #     template_base: {
        #       logo: 'ik_logo.png',
        #       logo_url: 'http://www.ikcrm.com/assets/img/ik_logo.png',
        #       title: '',
        #       text: ''
        #     }
        #   },
        #   opts: {
        #     push_type: 2
        #   }
        # }
        @igetui_config = opts['igetui']
        if @igetui_config.present?
          Igetui.config = @igetui_config['opts']
          Igetui::Push.config = @igetui_config['base']
        end
        # xiaomi default config
        # {
        #   restricted_package_name: 'com.vcooline.aike',
        #   pass_through: 1,
        #   title: 'xiaomi push',
        #   description: 'xiaomi push',
        #   notify_type: 1
        # }
        @xiaomi_config = opts['xiaomi']
        Xiaomi.config = @xiaomi_config

        # huawei default config
        @huawei_config = opts['huawei']
        Huawei.config = @huawei_config
      end

      # transmission_content 是真正的推送信息
      # {
        #   transmission_content: opts,
        #   transmission_type: transmission_type
        # }
      def push(user_device_ids, message)
        message = message.with_indifferent_access

        # igetui
        Igetui.push(user_device_ids, message)

        # xiaomi
        Xiaomi.push(user_device_ids, message['transmission_content'])

        # huawei
        Huawei.push(user_device_ids, message['transmission_content'])

        # etc
      rescue StandardError => err
        Log.error(err)
      end
    end
  end
end
