module AppPush
  module Xiaomi
    class << self
      attr_accessor :config
      def push(registration_id, payload)
        if registration_id.present?
          registration_id = registration_id.join(',') if registration_id.instance_of? Array
          post(message(payload, registration_id))
        end
      rescue StandardError => err
        AppPush::Log.error(err)
      end

      def message(payload, registration_id)
        message = config
        message[:registration_id] = registration_id
        message[:payload] = payload.to_json
        message
      end

      def config
        @config || default_config
      end

      def default_config
        {
          restricted_package_name: 'com.vcooline.aike',
          pass_through: 1,
          title: 'xiaomi push',
          description: 'xiaomi push',
          notify_type: 1
        }
      end

      def post(params)
        AppPush::Log.info("params: #{params.to_json}")
        url = 'https://api.xmpush.xiaomi.com/v3/message/regid'
        AppPush::Log.info("url: #{url}")
        response = HTTParty.post(url, query: params,
                                      headers: {
                                        'Accept' => 'application/json;',
                                        "Authorization": 'key=tQWrpyjb+47hdH/MSmfMGQ=='
                                      },
                                      timeout: 5)
        AppPush::Log.info("response: #{response}")
        response
      end
    end
  end
end
